﻿@using System.Web.UI.WebControls;


@using Toyota.Common.Web.Html;
@using Toyota.Common.Web.Html.Helper
@using Toyota.Common.Web.MVC;

@using DevExpress.Web.Mvc;
@using DevExpress.Web.Mvc.UI;
@using DevExpress.Utils;

@using Portal.Models.Receiving.KanbanPartShortage;


@Html.Common().DevExpress().GridView(
setting =>
{
    setting.Name = "GridKanbanPartShortage";
    setting.KeyFieldName = "KANBAN_NO";
    setting.CallbackRouteValues = new { Controller = "KanbanPartShortage", Action = "PartialData" };
    //setting.ClientSideEvents.Init = "gridDeliveryInvoice_Init";
    //setting.ClientSideEvents.CustomButtonClick = "func";
    //setting.ClientSideEvents.Init = "grid_init";
    setting.ClientSideEvents.BeginCallback = "OnBeginCallbackGrid";
    //setting.ClientSideEvents.EndCallback = "OnEndCallbackGrid";
    setting.Styles.Header.HorizontalAlign = HorizontalAlign.Center;
    setting.Width = Unit.Percentage(100);

    setting.Settings.ShowFilterRow = true;
    setting.Settings.ShowFilterRowMenu = true;
    setting.SettingsBehavior.AllowSelectSingleRowOnly = false;
    setting.SettingsBehavior.AllowSelectByRowClick = true;
    setting.CommandColumn.ClearFilterButton.Visible = true;
    setting.CommandColumn.ShowSelectCheckbox = true;
    setting.CommandColumn.Visible = true;
    setting.CommandColumn.Width = Unit.Pixel(30);
    setting.CommandColumn.FixedStyle = GridViewColumnFixedStyle.Left;
    setting.SettingsPager.PageSizeItemSettings.Visible = true;
    setting.SettingsPager.PageSizeItemSettings.Items = new string[] { "10", "30", "50", "100" };
    setting.SettingsPager.PageSizeItemSettings.Caption = "Page size";
    setting.Settings.HorizontalScrollBarMode = ScrollBarMode.Visible;
    setting.SettingsPager.FirstPageButton.Visible = true;
    setting.SettingsPager.LastPageButton.Visible = true;
    setting.CustomJSProperties = (sender, e) =>
    {
        MVCxGridView grid = (MVCxGridView)sender;
        int startIndex = 0;

        int endIndex = Model.GetModel<List<KanbanPartShortageData>>().Count;
        object[] KANBAN_NO = new object[endIndex - startIndex];
        object[] RECEIVE = new object[endIndex - startIndex];
        object[] SHORTAGE = new object[endIndex - startIndex];
        object[] PART_NO = new object[endIndex - startIndex];
        object[] MANIFEST_NO = new object[endIndex - startIndex];
        object[] isSelected = new object[endIndex - startIndex];

        for (int n = startIndex; n < endIndex; n++)
        {
            KANBAN_NO[n - startIndex] = grid.GetRowValues(n, "KANBAN_NO");
            RECEIVE[n - startIndex] = grid.GetRowValues(n, "RECEIVE");
            SHORTAGE[n - startIndex] = grid.GetRowValues(n, "SHORTAGE");
            PART_NO[n - startIndex] = grid.GetRowValues(n, "PART_NO");
            MANIFEST_NO[n - startIndex] = grid.GetRowValues(n, "MANIFEST_NO");
            isSelected[n - startIndex] = grid.Selection.IsRowSelected(n);
        }

        e.Properties["cpKanbanNo"] = KANBAN_NO;
        e.Properties["cpReceive"] = RECEIVE;
        e.Properties["cpShortage"] = SHORTAGE;
        e.Properties["cpPartNo"] = PART_NO;
        e.Properties["cpManifestNo"] = MANIFEST_NO;
        e.Properties["cpVisibleRowCount"] = grid.VisibleRowCount;
        e.Properties["cpFocusedRowIndex"] = grid.FocusedRowIndex;
        e.Properties["cpKeyfield"] = grid.KeyFieldName;
        e.Properties["cpIsRowSelected"] = isSelected;
        grid.JSProperties["cpPageSize"] = grid.SettingsPager.PageSize;
        grid.JSProperties["cpStartIndex"] = startIndex;
        grid.JSProperties["cpEndIndex"] = endIndex;
    };

    setting.HtmlDataCellPrepared = (sender, e) =>
    {
        if (e.DataColumn.FieldName == "REMARKED")
        {
            if (e.CellValue.ToString() != "0")
            {
                e.Cell.BackColor = System.Drawing.Color.Yellow;
                e.Cell.ForeColor = System.Drawing.Color.Black;
            }
        }
    };
    

    setting.ClientSideEvents.SelectionChanged = "CheckChange";
    setting.CommandColumn.SetHeaderTemplateContent(
    c =>
    {
        
        Html.DevExpress().CheckBox(
                chckBox =>
                {
                    chckBox.Name = "SelectAllCheckBoxs";
                    chckBox.Properties.ClientSideEvents.CheckedChanged = string.Format("function(s, e) {{ if(s.GetChecked()) {0}.SelectRows(); else {0}.UnselectRows(); }}", setting.Name);
                    chckBox.Checked = c.Grid.Selection.Count > 1;
                }
            ).Render();
    });

    setting.Columns.Add(col =>
    {
        col.FieldName = "KANBAN_ID";
        col.Caption = "Kanban ID";
        col.Width = 110;
        col.Visible = false;
        col.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
        col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;

    });


    setting.Columns.Add(col =>
    {
        col.FieldName = "KANBAN_NO";
        col.Caption = "Kanban No";
        col.Width = 70;
        col.FixedStyle = GridViewColumnFixedStyle.Left;
        col.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
        col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
        col.SetDataItemTemplateContent(container =>
        {
            Html.DevExpress().HyperLink(hlSettings =>
            {
                hlSettings.Name = string.Format("hlpr_{0}", (container as GridViewDataItemTemplateContainer).VisibleIndex);
                hlSettings.NavigateUrl = "javascript:void(0)";
                hlSettings.Properties.ClientSideEvents.Click = string.Format("function(s, e) {{ OpenPrint('{0}', '{1}', '{2}', '{3}', '{4}', '{5}'); }}", (container as GridViewDataItemTemplateContainer).Text, DataBinder.Eval(container.DataItem, "ORDER_NO"), DataBinder.Eval(container.DataItem, "PART_NO"), DataBinder.Eval(container.DataItem, "KANBAN_ID"), DataBinder.Eval(container.DataItem, "PART_NAME"), DataBinder.Eval(container.DataItem, "SUPPLIER_PLANT_CD"));
                hlSettings.Properties.Text = (container as GridViewDataItemTemplateContainer).Text;
            }).Render();
        });
    });

    setting.Columns.Add(col =>
    {
        col.FieldName = "PART_NAME";
        col.Caption = "Part Name";
        col.Width = 400;
        col.FixedStyle = GridViewColumnFixedStyle.Left;
        col.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Left;
        col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
    });
    setting.Columns.Add(col =>
    {
        col.FieldName = "PART_NO";
        col.Caption = "Part No";
        col.Width = 110;
        col.FixedStyle = GridViewColumnFixedStyle.Left;
        col.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
        col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
    });

    setting.Columns.Add(col =>
    {
        col.FieldName = "QTY_PER_CONTAINER";
        col.Caption = "Qty Per Kbn";
        col.Width = 90;
        col.FixedStyle = GridViewColumnFixedStyle.Left;
        col.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
        col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
    });

    setting.Columns.Add(col =>
    {
        col.FieldName = "SUPPLIER_CD";
        col.Caption = "Supplier Code";
        col.Width = 90;
        col.FixedStyle = GridViewColumnFixedStyle.Left;
        //col.Visible = false;
        col.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
        col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;

    });

    setting.Columns.Add(col =>
    {
        col.FieldName = "SUPPLIER_PLANT_CD";
        col.Caption = "Supplier Code";
        col.Width = 90;
        col.Visible = false;
        col.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
        col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;

    });

    setting.Columns.Add(col =>
    {
        col.FieldName = "SUPPLIER_NAME";
        col.Caption = "Supplier Name";
        col.Width = 400;
        col.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Left;
        col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;

    });

    setting.Columns.Add(col =>
    {
        col.FieldName = "ORDER_NO";
        col.Caption = "Order No";
        col.Width = 90;
        col.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
        col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;

    });

    setting.Columns.Add(col =>
    {
        col.FieldName = "MANIFEST_NO";
        col.Caption = "Manifest No";
        col.Width = 90;
        col.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
        col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;

    });

    setting.Columns.Add(col =>
    {
        col.FieldName = "RCV_PLANT_CD";
        col.Caption = "Rcv Plant CD";
        col.Width = 90;
        col.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
        col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;

    });

    setting.Columns.Add(col =>
    {
        col.FieldName = "RCV_DOCK_CD";
        col.Caption = "Rcv Dock Cd";
        col.Width = 90;
        col.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
        col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;

    });

    setting.Columns.Add(col =>
    {
        col.FieldName = "P_LANE_SEQ";
        col.Caption = "Progress Lane";
        col.Width = 110;
        col.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
        col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;

    });

    setting.Columns.AddBand(
   columnBand =>
   {
       columnBand.Caption = "Total Kanban";
       //columnBand.Width = Unit.Percentage(50);
       columnBand.Columns.Add(
           column =>
           {

               column.Caption = "Order";
               column.Name = "ORDER";
               column.FieldName = "ORDER";
               column.Width = 70;
               column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
               column.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
           }
           );

       columnBand.Columns.Add(
           column =>
           {
               column.Caption = "Shortage";
               column.Name = "SHORTAGE";
               column.FieldName = "SHORTAGE";
               column.Width = 70;
               column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
               column.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
           }
           );

       columnBand.Columns.Add(
                       column =>
                       {
                           column.Caption = "Receive";
                           column.FieldName = "RECEIVE";
                           column.Width = Unit.Pixel(80);
                           column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                           column.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
                           column.SetDataItemTemplateContent(c =>
                           {
                               var x = (c as GridViewDataItemTemplateContainer).Text;
                               var a = (c as GridViewDataItemTemplateContainer).VisibleIndex;

                               string[] y = x.Split('|');

                                if(x!="0")
                                {
                                   Html.DevExpress().TextBox(
                                   tboxSettings =>
                                   {
                                       tboxSettings.Name = string.Format("txtReceive[{0}]", (c as GridViewDataItemTemplateContainer).VisibleIndex);
                                       tboxSettings.Width = Unit.Pixel(50);
                                       tboxSettings.Enabled = true;
                                       tboxSettings.Properties.Style.ForeColor = System.Drawing.Color.Black;
                                       tboxSettings.Style.Add("display", "inline-table");
                                   
                                   }).Render(); 
                                }
                                else
                                {
                                    Html.DevExpress().Label(lbSetting =>
                                    {
                                        lbSetting.Text = "";
                                    }).Render();
                                }
                               

                               

                           });
                       }
           );
   });


    setting.Columns.AddBand(
            columnBand =>
            {
                columnBand.Caption = "Arrival Time";
                columnBand.Name = "ARRIVAL_TIME";
                columnBand.Visible = true;
                columnBand.Columns.Add(
                    column =>
                    {
                        column.Caption = "Plan";
                        column.Name = "ARRIVAL_PLAN_DT";
                        column.FieldName = "ARRIVAL_PLAN_DT";
                        column.ColumnType = MVCxGridViewColumnType.DateEdit;
                        column.PropertiesEdit.DisplayFormatString = "dd.MM.yyyy HH:mm:ss";
                        var dateEditProperties = column.PropertiesEdit as DateEditProperties;
                        dateEditProperties.EditFormat = EditFormat.DateTime;
                        dateEditProperties.EditFormatString = "dd.MM.yyyy HH:mm:ss";
                        dateEditProperties.UseMaskBehavior = true;
                        column.Width = Unit.Pixel(140);
                        column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                        column.Settings.AutoFilterCondition = AutoFilterCondition.Contains;

                    }
                );

                columnBand.Columns.Add(
                    column =>
                    {
                        column.Caption = "Actual";
                        column.Name = "ARRIVAL_ACTUAL_DT";
                        column.FieldName = "ARRIVAL_ACTUAL_DT";
                        column.ColumnType = MVCxGridViewColumnType.DateEdit;
                        column.PropertiesEdit.DisplayFormatString = "dd.MM.yyyy HH:mm:ss";
                        var dateEditProperties = column.PropertiesEdit as DateEditProperties;
                        dateEditProperties.EditFormat = EditFormat.DateTime;
                        dateEditProperties.EditFormatString = "dd.MM.yyyy HH:mm:ss";
                        dateEditProperties.UseMaskBehavior = true;
                        column.Width = Unit.Pixel(140);
                        column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                        column.Settings.AutoFilterCondition = AutoFilterCondition.Contains;

                    }
                );
            }
    );




    setting.Columns.Add(col =>
    {
        col.FieldName = "ROUTE_RATE";
        col.Caption = "Route - Rit";
        col.Width = 90;
        col.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
        col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;

    });

    setting.Columns.Add(
       col =>
       {
           col.Settings.ShowFilterRowMenu = DefaultBoolean.False;
           col.Settings.AllowAutoFilter = DefaultBoolean.False;
           col.Caption = "Remark";
           col.FieldName = "REMARKED";
           col.Width = Unit.Pixel(50);
           col.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
           col.CellStyle.VerticalAlign = VerticalAlign.Middle;
           col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
           col.SetDataItemTemplateContent(container =>
           {
               ViewContext.Writer.Write(
                "<a href=\"javascript:void(0)\" onClick=\"remark('" + DataBinder.Eval(container.DataItem, "KANBAN_NO") + "','" + DataBinder.Eval(container.DataItem, "MANIFEST_NO") + "','" + DataBinder.Eval(container.DataItem, "ORDER_NO") + "','" + DataBinder.Eval(container.DataItem, "PART_NO") + "')\">"
                );
               Html.DevExpress().Image(
                    img =>
                    {
                        img.Properties.ImageAlign = ImageAlign.Middle;
                        img.ImageUrl = "~/Content/Images/remark.png";
                    }).Render();
               ViewContext.Writer.Write(
                   "</a>"
                );
           });
       }
    );

    //setting.Columns.Add(
    //                   column =>
    //                   {
    //                       column.Caption = "Remark";
    //                       column.FieldName = "REMARK";
    //                       column.Width = Unit.Pixel(150);
    //                       column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
    //                       column.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
    //                       column.SetDataItemTemplateContent(c =>
    //                       {
    //                           var x = (c as GridViewDataItemTemplateContainer).Text;
    //                           var a = (c as GridViewDataItemTemplateContainer).VisibleIndex;

    //                           //string[] y = x.Split('|');
    //                           //if (y[0] == "yes" && y[1] == "")
    //                           //{
    //                           string y = x.Trim();
    //                           if(x=="NOTHING")
    //                           {
    //                                   Html.DevExpress().TextBox(
    //                                  tboxSettings =>
    //                                  {
    //                                      tboxSettings.Name = string.Format("txtSA_Notes[{0}]", (c as GridViewDataItemTemplateContainer).VisibleIndex);
    //                                      tboxSettings.Width = Unit.Pixel(90);
    //                                      tboxSettings.Enabled = true;
    //                                      tboxSettings.Properties.Style.ForeColor = System.Drawing.Color.Black;
    //                                      tboxSettings.Style.Add("display", "inline-table");

    //                                  }
    //                                 ).Render();

    //                                   Html.DevExpress().Button(
    //                                   button =>
    //                                   {
    //                                       button.Name = string.Format("btnOK[{0}]", (c as GridViewDataItemTemplateContainer).VisibleIndex);
    //                                       button.Text = "OK";
    //                                       button.Width = Unit.Pixel(15);
    //                                       button.Height = Unit.Pixel(10);
    //                                       button.UseSubmitBehavior = true;
    //                                       button.Style.Add("display", "inline-table");
    //                                       button.ControlStyle.CssClass = "btnOkeh";

    //                                       //button.ClientSideEvents.Click = "saveNotes("+a.ToString()+")";
    //                                       button.ClientSideEvents.Click = string.Format("function(s,e){{ saveNotes({0}, '{1}', '{2}','{3}','{4}'); }}", (c as GridViewDataItemTemplateContainer).VisibleIndex, DataBinder.Eval(c.DataItem, "KANBAN_ID"), DataBinder.Eval(c.DataItem, "MANIFEST_NO"), DataBinder.Eval(c.DataItem, "ORDER_NO"), DataBinder.Eval(c.DataItem, "PART_NO"));

    //                                   }).Render();
    //                           }
    //                           else
    //                           {


    //                                Html.DevExpress().Label(lbSetting =>
    //                                {
    //                                    lbSetting.Text = x;
    //                                }).Render();
    //                           }
    //                       });
    //                   }
    //       );


}).Bind(Model.GetModel<List<KanbanPartShortageData>>()).GetHtml()